#include "../create_windows.h"

void create_multiple_resizeable_top_level_window(void) {
	const int N = 10;
	Window windows[N];
	Window children[N];

	for(auto i = 0; i < N; i++) {
		windows[i] = XCreateSimpleWindow(test_display, test_root,
				10 /*x*/, 10 /*y*/, 128 /*w*/, 128 /*h*/,
				0 /*TODO: border width*/, CopyFromParent /*depth*/, blue(((float) i+1)/N).pixel /* background */);
		// The top level windows might have children. Those must **not** be
		// altered by the Window Manager
		children[i] = XCreateSimpleWindow(test_display, windows[i],
				0, 0, 25, 30,
				0, CopyFromParent, red(1).pixel);
		XMapWindow(test_display, children[i]);
		XMapWindow(test_display, windows[i]);
	}

	
	int visibility[N];
	wait_array_visibility(test_display, N, windows, visibility);

	for(auto i = 0; i < N; i++) {
		// All top level windows must be fully visible
		XWindowAttributes attributes;
		XGetWindowAttributes(test_display, windows[i], &attributes);
		TEST_ASSERT_EQUAL_INT(VisibilityUnobscured, visibility[i]);
		TEST_ASSERT_EQUAL_INT(IsViewable, attributes.map_state);

		// Check the children structure is unaltered
		TEST_ASSERT_EQUAL(parent(test_display, children[i]), windows[i]);

		XWindowAttributes child_attributes;
		XGetWindowAttributes(test_display, children[i], &child_attributes);

		TEST_ASSERT_EQUAL_INT(0, child_attributes.x);
		TEST_ASSERT_EQUAL_INT(0, child_attributes.y);
		TEST_ASSERT_EQUAL_INT(25, child_attributes.width);
		TEST_ASSERT_EQUAL_INT(30, child_attributes.height);
		TEST_ASSERT_EQUAL_INT(0, child_attributes.border_width);
		TEST_ASSERT_EQUAL_INT(IsViewable, child_attributes.map_state);
	}
}
